#!/usr/bin/python
"""A comments feedback CGI thing for pyllbox."""

import sys, os, cgi, time, glob

env = os.environ
method = env.get('REQUEST_METHOD')
uri = env.get('REQUEST_URI', '')
base = env.get('REQUEST_URI', '').split('/')
base.pop()
base = '/'.join(base)
if not base.endswith('/'): 
   base += '/'
path = uri[len(base):]

def getForm(): 
   result = {}
   form = cgi.parse_qs(sys.stdin.read())
   for item in form.items(): 
      result[item[0]] = ''.join(item[1])
   return result

def serve(mime, s): 
   sys.stdout.write('Content-Type: %s\r\n' % mime)
   sys.stdout.write('\r\n')
   sys.stdout.write(s)

def timenow(): 
   t = str(time.time())
   t = t[((t.rfind('.') + 1) or len(t)):]
   return time.strftime('%Y%m%d%H%M%S', time.gmtime()) + t

def smarttime(): 
   return time.strftime('%Y-%m-%d %H:%M:%S', time.gmtime())

def trim(s): 
   while s.startswith('\n') or s.startswith('\r'): 
      s = s[1:] # s = s.lstrip('\r\n')
   if s.endswith('\n'): s = s[:-1]

   i = 0
   for char in s: 
      if char == ' ': i += 1
      else: break

   result, lines = '', s.splitlines()
   for line in lines: 
      if line.startswith(' ' * i): 
         result += line[i:] + '\n'
      else: result += line + '\n'

   return result

def html(title, s): 
   return trim("""
      <html xmlns="http://www.w3.org/1999/xhtml" 
         xml:lang="en" >
      <head>
      <title>%s</title>
      <link rel="stylesheet" href="../style.css" type="text/css" />
      </head>
      <body>
      %s
      </body>
      </html>
   """) % (title, s)

def doAdd(form): 
   s = ''
   comment = form.get('comment')
   if comment: 
      comment = comment.replace('\r\n', '\n')
      comment = comment.replace('\r', '\n')
      comment = cgi.escape(comment)
      paragraphs = comment.split('\n\n')
      s += '<blockquote>'
      for p in paragraphs: 
         s += '<p>%s</p>\n\n' % p
      s += '</blockquote>'
   else: return ('text/html', html('Error', 'Form needs a comment!'))

   name = form.get('name')
   if name: 
      s += '<p>&#x2014;By %s on %s.</p>\n' % (cgi.escape(name), smarttime())
   else: return ('text/html', html('Error', 'Form needs a name!'))

   # @@ check that the path exists
   f = open('%s-%s.txt' % (path, timenow()), 'w')
   f.write(s)
   f.close()

   msg = '<p>Done! Return to <a href="./%s">comments</a>.</p>' % path
   return ('text/html', html('Your Comment Has Been Submitted', msg))

def doShow(): 
   if os.path.exists('../%s.txt' % path): 
      entry = open('../%s.txt' % path).read()
      lines = entry.splitlines()
      title = lines[0]
   else: return ('text/html', html('Error', 'No such entry: %s' % path))

   s = '<div class="header">\n<h1><a href="/">$${blogname}</a></h1>\n'
   s += '<span>&nbsp;&#x2014;&nbsp;The Weblog of $${authorname}</span>\n'
   s += '</div>\n'
   s += '<p>Post a comment on "<a href="/%s">%s</a>": </p>\n' % (path, title)
   s += '<form action="./%s" method="POST">\n' % path
   s += '<div><textarea rows="7" cols="70" name="comment">'
   s += '</textarea> <input type="hidden" name="action" value="add" /></div>\n'
   s += '<div>Your name/homepage/email: <input type="text" \n'
   s += 'size="25" name="name" /> <input type="submit" /></div>\n'
   s += '</form>\n'
   s += '<p>Current comments on "<a href="/%s">%s</a>": </p>\n' % (path, title)
   filenames = glob.glob('%s-*.txt' % path)
   filenames.sort()
   for fn in filenames: 
      i = fn.find('-')
      nid = fn[i+1:-len('.txt')]
      s += '<div id="%s" class="entry">\n' % nid
      s += open(fn).read()
      s += '</div>\n'
   return ('text/html', html('Comment on %s' % path, s))

def doHomepage(): 
   filenames = glob.glob('*-*.txt')
   for i in range(len(filenames)): 
      j = filenames[i].find('-')
      filenames[i] = filenames[i][j:]
   filenames.sort()
   s = '<p>Most recent comments: </p>'
   s += '<ul>\n'
   for fn in filenames[-10:]: 
      f = glob.glob('*%s' % fn)[0]
      post = f[:f.find('-')]
      nid = f[f.find('-')+1:-len('.txt')]
      s += '<li><a href="./%s#id%s">%s %s</a></li>\n' % (post, nid, post, nid)
   s += '</ul>\n'
   return ('text/html', html('Latest comments', s))

def main(env=env): 
   if method == 'POST': 
      form = getForm()
      action = form.get('action', '')
      if action == 'add': 
         apply(serve, doAdd(form))
      else: serve('text/plain', 'Unknown action: %s' % action)
   elif path: 
      apply(serve, doShow())
   else: apply(serve, doHomepage())

if __name__=="__main__": 
   try: main()
   except: cgi.print_exception()
